package com.logicbig.example;

import org.springframework.hateoas.Link;
import org.springframework.hateoas.LinkBuilder;
import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/employees")
public class EmployeeController {

    @GetMapping("/{employeeId}")
    public Employee getEmployeeById(@PathVariable long employeeId) {
        Employee employee = getEmployee(employeeId);
        Link selfLink = ControllerLinkBuilder.linkTo(EmployeeController.class)
                                         .slash(employee.getEmployeeId())
                                         .withSelfRel();
        employee.add(selfLink);
        return employee;
    }

    private Employee getEmployee(long employeeId) {
        //todo: replace following with employee service
        return Employee.create(employeeId, "Tom", "Admin", 3000);
    }
}